Track (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.sound.midi, class: Track
Keywords: javax.sound.midi.Track class

# Class Track

java.lang.Object
javax.sound.midi.Track

public final class Track extends Object
A MIDI track is an independent stream of MIDI events (time-stamped MIDI data) that can be stored along with other tracks in a standard MIDI file. The MIDI specification allows only 16 channels of MIDI data, but tracks are a way to get around this limitation. A MIDI file can contain any number of tracks, each containing its own stream of up to 16 channels of MIDI data.

A `Track` occupies a middle level in the hierarchy of data played by a `Sequencer`: sequencers play sequences, which contain tracks, which contain MIDI events. A sequencer may provide controls that mute or solo individual tracks.

The timing information and resolution for a track is controlled by and stored in the sequence containing the track. A given `Track` is considered to belong to the particular `Sequence` that maintains its timing. For this reason, a new (empty) track is created by calling the `Sequence.createTrack()` method, rather than by directly invoking a `Track` constructor.

The `Track` class provides methods to edit the track by adding or removing `MidiEvent` objects from it. These operations keep the event list in the correct time order. Methods are also included to obtain the track's size, in terms of either the number of events it contains or its duration in ticks.

See Also:
  - `Sequencer.setTrackMute(int, boolean)`
  - `Sequencer.setTrackSolo(int, boolean)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `add(MidiEvent event)`
  Adds a new event to the track.
  `MidiEvent`
  `get(int index)`
  Obtains the event at the specified index.
  `boolean`
  `remove(MidiEvent event)`
  Removes the specified event from the track.
  `int`
  `size()`
  Obtains the number of events in this track.
  `long`
  `ticks()`
  Obtains the length of the track, expressed in MIDI ticks.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Method Details

  - ### add

    public boolean add(MidiEvent event)
    Adds a new event to the track. However, if the event is already contained in the track, it is not added again. The list of events is kept in time order, meaning that this event inserted at the appropriate place in the list, not necessarily at the end.
    Parameters:
      `event` - the event to add
    Returns:
      `true` if the event did not already exist in the track and was added, otherwise `false`

  - ### remove

    public boolean remove(MidiEvent event)
    Removes the specified event from the track.
    Parameters:
      `event` - the event to remove
    Returns:
      `true` if the event existed in the track and was removed, otherwise `false`

  - ### get

    public MidiEvent get(int index) throws ArrayIndexOutOfBoundsException
    Obtains the event at the specified index.
    Parameters:
      `index` - the location of the desired event in the event vector
    Returns:
      the event at the specified index
    Throws:
      `ArrayIndexOutOfBoundsException` - if the specified index is negative or not less than the current size of this track
    See Also:
      - `size()`

  - ### size

    public int size()
    Obtains the number of events in this track.
    Returns:
      the size of the track's event vector

  - ### ticks

    public long ticks()
    Obtains the length of the track, expressed in MIDI ticks. (The duration of a tick in seconds is determined by the timing resolution of the `Sequence` containing this track, and also by the tempo of the music as set by the sequencer.)
    Returns:
      the duration, in ticks
    See Also:
      - `Sequence(float, int)`
      - `Sequencer.setTempoInBPM(float)`
      - `Sequencer.getTickPosition()`